/**
  Problema ACSL Tiles - Contest#1,
Junior - 2023/2024 originală:
  - datele de intrare ale problemei sunt citit ca string-uri.
Și anume:
- numărul de 4 cifre, care reprezintă
  numărul cu care începe fiecare rând - este un string
- șirul de numere cu exact 2 cifre fiecare, care reprezintă
piesele ce se dau - este de asemenea un string.

   Cele două stringuri sunt parametri ale unei funcții.

   Voi trebuie să completați codul funcției ca să dea direct rezultatul.
Pe exemplul dat în problemă stringurile sunt acestea:
table="5923"
pieces="56 85 27 73 14 34 62"
*/
#include <iostream>
using namespace std;

int solve(string table,string pieces)
{
    ///aici trebuie să facem rezolvarea
    int rows,r1,r2,r3,r4,tile,c1,c2,discard_sum=0;
    ///rows=primul număr citit
    ///r1, r2, r3, r4 = în ele reținem ultimul număr
    ///    adică cel cu care se termină fiecare dintre
    ///    cele 4 rânduri
    ///  tile = piesa curentă (formată din 2 cifre)
    ///  c1, c2 = cifrele din piesa curentă
    ///  discard_sum = suma rezultat
    r1=table[0]-48;///table[0]-'0'; -fiidn caracter cifră tre' convertit la număr
    r2=table[1]-48;
    r3=table[2]-48;
    r4=table[3]-48;
    ///pregătim citirea pieselor: le separăm din string
    pieces=pieces+" ";
    int poz;
    while(pieces!="")
    {
        ///extragem numărul curent din string
        poz=pieces.find(" ");
        tile=stoi(pieces.substr(0,poz));
        pieces.erase(0,poz+1);
        c1=tile/10;
        c2=tile%10;
        ///verificăm toate potrivirile posibile
        ///începem cu r1:
        if(r1==c1)r1=c2;
        else if(r1==c2)r1=c1;
        else if(r2==c1)r2=c2;
        else if(r2==c2)r2=c1;
        else if(r3==c1)r3=c2;
        else if(r3==c2)r3=c1;
        else if(r4==c1)r4=c2;
        else if(r4==c2)r4=c1;
        else discard_sum+=c1+c2;
    }
    ///funcția la final trebuie să întoarcă rezultatul
    ///deci să aibă "return rezultat;"
    return discard_sum;
}


int main()
{
    string s1,s2;
    getline(cin,s1);
    getline(cin,s2);
    cout<<solve(s1,s2);
    return 0;
}
